#include "StdAfx.h"
#include "CDialogOpenAL.h"

////
//	Construct the object.
////

CDialogOpenAL::CDialogOpenAL():tr_al_init(false),volume_max(1)
{}

////
//	Start the dialog.
////

void CDialogOpenAL::Start()
{
	int screen_w(800);
	int screen_h(600);

// ------- Create Window -----------------------------------
	tr_mng_wnd = new CSkinManageWndTR("URCDlgOption2", false);
	tr_dlg = new CSkinWindowTR("TR Chat dialog2",0,0,screen_w,screen_h,TR_SKIN_WINDOW_POPUP);
//	(*tr_dlg)->Execute();
	(*tr_dlg)->SetWndKind(TR_SKIN_OPENGL,screen_w,screen_h, false);
	(*tr_dlg)->SetWindowManager(tr_mng_wnd);
	(*tr_dlg)->Center();

// ------- Create Color -----------------------------------
	CSkinColorRGBASP color_white = new CSkinColorRGBA(1,1,1,1);
	CSkinColorRGBASP color_white_trans = new CSkinColorRGBA(1,1,1,0.7);

// ------- Load texture -----------------------------------
	CImageSPTR tr_texture_interface = new CImageTR("Interface");
	(*tr_texture_interface)->Load("./Images/InterfaceTROpenALTutorial.jpg", TR_IMG_JPEG);

	CImageSPTR texture_default_out = new CImageTR("SkinDefaultInterfaceOut");
	(*texture_default_out)->Load("./Images/InterfaceOut.tga", TR_IMG_TGA);

	CImageSPTR texture_default_over = new CImageTR("SkinDefaultInterfaceOver");
	(*texture_default_over)->Load("./Images/InterfaceOver.tga", TR_IMG_TGA);

	CImageSPTR texture_default_down = new CImageTR("SkinDefaultInterfaceDown");
	(*texture_default_down)->Load("./Images/InterfaceDown.tga", TR_IMG_TGA);

// ------- Logo Picture -----------------------------------
	CPictureSPTR t_pic_logo_openal = new CPictureTR(0, (screen_w-161)>>1,screen_h-85,161,86, tr_texture_interface, 0,0,161,86);
	(*t_pic_logo_openal)->ChangeColor(color_white_trans);

	CPictureSPTR t_pic_logo_tr = new CPictureTR(0, (screen_w-screen_h)>>1,0,screen_h,screen_h, tr_texture_interface, 171,0,85,86);
	(*t_pic_logo_tr)->ChangeColor(color_white);
	(*t_pic_logo_tr)->Disable();
// ------- Buttons -----------------------------------
	// Close
	CButtonBoxSPTR t_bt_box_close = new CButtonBoxTR("Close", 0, screen_w-20, 0, 19, 19, 19,19, texture_default_out, 1, 108, texture_default_over, 1, 108, texture_default_down, 1, 108);
	(*t_bt_box_close)->SetActionOnEndMouseClick(new CClassFunctionTR<CDialogOpenAL>(*this,0,&CDialogOpenAL::Close));
	(*t_bt_box_close)->ChangeColor(color_white);

	// Minimize
	CButtonBoxSPTR t_bt_box_minimize = new CButtonBoxTR("Minimize", 0, screen_w-40, 0, 19, 19, 19,19, texture_default_out, 20, 109, texture_default_over, 20, 109, texture_default_down, 20, 109);
	(*t_bt_box_minimize)->SetActionOnEndMouseClick(new CClassFunctionTR<CDialogOpenAL>(*this,0,&CDialogOpenAL::Minimize));
	(*t_bt_box_minimize)->ChangeColor(color_white);

// ------- Sounds buttons -----------------------------------

	// Sound button WAV on/off
	CButtonBoxSPTR t_bt_sound_wav = new CButtonBoxTR("Sound button WAV on/off", 0, ((screen_w/3)-85)/2, (screen_h-85)/2, 85, 85, 85, 85, tr_texture_interface, 0, 171, tr_texture_interface, 0, 86, tr_texture_interface, 0, 86);
	(*t_bt_sound_wav)->SetActionOnStartMouseClick(new CClassFunctionTR<CDialogOpenAL>(*this,0,&CDialogOpenAL::PlayWav));
	(*t_bt_sound_wav)->ChangeColor(color_white);

	// Sound button WAV Multi on/off
	CButtonBoxSPTR t_bt_sound_wav_multi = new CButtonBoxTR("Sound button WAV Multi on/off", 0, screen_w/3+((screen_w/3)-85)/2, (screen_h-85)/2, 85, 85, 85, 85, tr_texture_interface, 170, 171, tr_texture_interface, 170, 86, tr_texture_interface, 170, 86);
	(*t_bt_sound_wav_multi)->SetActionOnStartMouseClick(new CClassFunctionTR<CDialogOpenAL>(*this,0,&CDialogOpenAL::PlayMultiChannel));
	(*t_bt_sound_wav_multi)->ChangeColor(color_white);

	// Sound button Ogg on/off
	tr_bt_sound_ogg = new CCheckBoxTR("Sound button Ogg on/off", 0, screen_w*2/3+((screen_w/3)-85)/2, (screen_h-85)/2, 85, 85, 85, 85, tr_texture_interface, 85, 171, tr_texture_interface, 85, 86, tr_texture_interface, 85, 86);
	(*tr_bt_sound_ogg)->SetActionOnStartMouseClick(new CClassFunctionTR<CDialogOpenAL>(*this,0,&CDialogOpenAL::PlayOgg));
	(*tr_bt_sound_ogg)->SetActionOnEndMouseClick(new CClassFunctionTR<CDialogOpenAL>(*this,0,&CDialogOpenAL::PlayOgg));
	(*tr_bt_sound_ogg)->ChangeColor(color_white);

// ------- Sounds buttons -----------------------------------

	// Sound volume
	tr_volume_sound = new CSliderBoxTR("Sound Slider", screen_w-112, screen_h-56, 112, 56, 56, 28,
						texture_default_out, 30, 48,
						texture_default_over, 30, 48, texture_default_down, 30, 48, 3);
	(*tr_volume_sound)->SetActionOnStartMouseOver(new CClassFunctionTR<CDialogOpenAL>(*this, 0, &CDialogOpenAL::SetSoundVolume));
	(*tr_volume_sound)->SetSliderValue(1);


	// Sound button on/off
	bt_sound_on = new CCheckBoxTR("Sound button on/off", 0, 0, screen_h-56, 56, 56, 28, 28, texture_default_out, 1, 48, texture_default_over, 1, 48, texture_default_down, 1, 48);
	(*bt_sound_on)->SetActionOnStartMouseClick(new CClassFunctionTR<CDialogOpenAL>(*this,0,&CDialogOpenAL::SetSoundVolumeOnOff));
	(*bt_sound_on)->SetActionOnEndMouseClick(new CClassFunctionTR<CDialogOpenAL>(*this,0,&CDialogOpenAL::SetSoundVolumeOnOff));
	(*bt_sound_on)->ChangeColor(color_white);

// ------- Add object to draw -----------------------------------

	(*tr_mng_wnd)->AddDrawObject(t_pic_logo_tr);
	(*tr_mng_wnd)->AddDrawObject(t_pic_logo_openal);
	(*tr_mng_wnd)->AddDrawObject(t_bt_sound_wav);
	(*tr_mng_wnd)->AddDrawObject(t_bt_sound_wav_multi);
	(*tr_mng_wnd)->AddDrawObject(tr_bt_sound_ogg);
	(*tr_mng_wnd)->AddDrawObject(bt_sound_on);
	(*tr_mng_wnd)->AddDrawObject(t_bt_box_close);
	(*tr_mng_wnd)->AddDrawObject(t_bt_box_minimize);
	(*tr_mng_wnd)->AddDrawObject(tr_volume_sound);

// ------- OpenAL Part, setting sound to load -----------------------------------

	// ------- Load and play wav sound ---------
	tr_al_listener.SetVolume(volume_max);
	tr_al_sound.Load("laser.wav","./Sounds/laser.wav",false);

	// ------- Load and play wav sound at the same time ---------
	tr_sp_al_multi_sound = new CMultiSoundAL(700, 150);
	(*tr_sp_al_multi_sound)->Load("laser.wav","./Sounds/laser.wav",false);

	// ------- Load and play stereo ogg file (stereo ogg file can't be use in 3D environment, only mono) ---------
	tr_al_ogg_sound.Load("Music","./sounds/StageMusic.ogg",false);
	tr_al_ogg_sound.SetActionOnStop(new CClassFunctionTR<CDialogOpenAL>(*this,0,&CDialogOpenAL::StopOgg));
}

////
//	Play wav
////

void CDialogOpenAL::PlayWav()
{
	tr_al_sound.Play();
}

////
//	Play Multi Channel
////

void CDialogOpenAL::PlayMultiChannel()
{
	if((*tr_sp_al_multi_sound)->IsPlaying())
		(*tr_sp_al_multi_sound)->Stop();
	else
		(*tr_sp_al_multi_sound)->Play();
}

////
//	Play Ogg
////

void CDialogOpenAL::PlayOgg()
{
	if(tr_al_ogg_sound.IsStop())
		tr_al_ogg_sound.Play();
	else
		tr_al_ogg_sound.Pause();
}

////
//	Stop Ogg
////

void CDialogOpenAL::StopOgg()
{
	(*tr_bt_sound_ogg)->SetCheck(false);
}

////
//	Close dialog .
////

void CDialogOpenAL::Close()
{
	(*tr_dlg)->Close();
}

////
//	Minimize dialog .
////

void CDialogOpenAL::Minimize()
{
	(*tr_dlg)->Minimize();
}

////
//	Set sound volume
////

void CDialogOpenAL::SetSoundVolume()
{
	// Get the slider position and set the minimum sound at 0.1 (0 is no sound)
	float t_volume_min = (*tr_volume_sound)->GetSliderValue()*volume_max;
	if(t_volume_min<0.1)
		t_volume_min=0.1;

	// Update listener sound volume
	tr_al_listener.SetVolume(t_volume_min);

	// If no sound check, unset no sound check button
	if((*bt_sound_on)->IsCheck())
		(*bt_sound_on)->SetCheck(false);
}

////
//	Set sound volume
////

void CDialogOpenAL::SetSoundVolumeOnOff()
{
	// Call from the check button
	if((*bt_sound_on)->IsCheck())
		tr_al_listener.SetVolume(0);
	else
		tr_al_listener.SetVolume(volume_max*(*tr_volume_sound)->GetSliderValue());
}