
#ifndef __CDialogOpenAL__
#define __CDialogOpenAL__

///----------------------------------------------------------------------------------------
//		This Class Design by Renan LAVAREC
//
//	+->	CDialogOpenAL																<-+
//	+->	Version 1.0 (Windows)														<-+
//
//	||> Show how to use OpenAL through L-TR											<||
//
//		Language C++.
//
//		<*>Contain:
//			CDialogOpenAL
//
//
//		This is free to use and modify provided my name is included.
///----------------------------------------------------------------------------------------

#include <L-TR.h>

/* --------------------------------------------------------------------------- */
/*	CDialogOpenAL															   */
/* --------------------------------------------------------------------------- */

class CDialogOpenAL
{
	private:
		// Hold chat dialog
		CSkinWindowSPTR tr_dlg;

		// Skin Window Manager
		CSkinManageWndSPTR tr_mng_wnd;

		// Skin use to diplay common control
		CSkinInterfaceTR *tr_skin_interface;
		
		// Check button
		CCheckBoxSPTR tr_bt_sound_ogg;

		// OpenAL objects
		CInitOpenAL tr_al_init;							// Automatically set the OpenAL environment
		CListenerAL	tr_al_listener;						// Listener, use to listen every sound of the world
		CSoundAL	tr_al_sound;						// Wav sound for short sound
		CSoundOggAL	tr_al_ogg_sound;					// Wav sound for multi sounds
		CMultiSoundALSP tr_sp_al_multi_sound;			// Ogg sound to play a music

		// Volume slider
		CSliderBoxSPTR tr_volume_sound;
		int volume_max;

		// Sound button on/off
		CCheckBoxSPTR bt_sound_on;

	public:

		////
		//	Construct the object.
		////

		CDialogOpenAL();

		////
		//	Start the dialog.
		////

		void Start();

		////
		//	Play wav
		////

		void PlayWav();

		////
		//	Play Multi Channel
		////

		void PlayMultiChannel();

		////
		//	Play Ogg
		////

		void PlayOgg();

		////
		//	Stop Ogg
		////

		void StopOgg();

		////
		//	Close dialog .
		////

		void Close();

		////
		//	Minimize dialog .
		////

		void Minimize();

		////
		//	Set sound volume
		////

		void SetSoundVolume();

		////
		//	Set sound volume
		////

		void SetSoundVolumeOnOff();
};


#endif //__CDialogOpenAL__
