// TROpenALTutorial.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "TROpenALTutorial.h"

#include <L-TR.h>
#include "CDialogOpenAL.h"


int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	try
	{
		CErrorTR::TRSetMode(TR_ERROR_OUTPUT_MSGBOX);
		
		CDialogOpenAL openal_dlg;
		openal_dlg.Start();

		// Enable to launch all windows and use event.
		CSkinWindowTR::Run();
	}
    catch ( const std::bad_alloc & )
    {
         CErrorTR::TRThrowError("Error","not enought memory",TR_ERROR);
    }
    catch ( const std::out_of_range & )
    {
         CErrorTR::TRThrowError("Error","memory out of range",TR_ERROR);
    }
    catch ( const CExceptionExitTR & )
    {
		// Exit directly
    }
	catch ( const std::exception &e ) // traite toutes les autres exceptions
	{
		CErrorTR::TRThrowError("Error",e.what(),TR_ERROR);
	}
	catch ( ... ) // traite toutes les autres exceptions
	{
		CErrorTR::TRThrowError("Error","Unknow Error",TR_ERROR);
	}
	return 0;
}
